
#ifndef __VSC_H__
#define __VSC_H__

#include <glib.h>
#include <glib-object.h>
#include <vala.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

G_BEGIN_DECLS


#define VSC_TYPE_SYMBOL_COMPLETION (vsc_symbol_completion_get_type ())
#define VSC_SYMBOL_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SYMBOL_COMPLETION, VscSymbolCompletion))
#define VSC_SYMBOL_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SYMBOL_COMPLETION, VscSymbolCompletionClass))
#define VSC_IS_SYMBOL_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SYMBOL_COMPLETION))
#define VSC_IS_SYMBOL_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SYMBOL_COMPLETION))
#define VSC_SYMBOL_COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SYMBOL_COMPLETION, VscSymbolCompletionClass))

typedef struct _VscSymbolCompletion VscSymbolCompletion;
typedef struct _VscSymbolCompletionClass VscSymbolCompletionClass;
typedef struct _VscSymbolCompletionPrivate VscSymbolCompletionPrivate;

#define VSC_TYPE_SYMBOL_COMPLETION_ITEM (vsc_symbol_completion_item_get_type ())
#define VSC_SYMBOL_COMPLETION_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SYMBOL_COMPLETION_ITEM, VscSymbolCompletionItem))
#define VSC_SYMBOL_COMPLETION_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SYMBOL_COMPLETION_ITEM, VscSymbolCompletionItemClass))
#define VSC_IS_SYMBOL_COMPLETION_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SYMBOL_COMPLETION_ITEM))
#define VSC_IS_SYMBOL_COMPLETION_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SYMBOL_COMPLETION_ITEM))
#define VSC_SYMBOL_COMPLETION_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SYMBOL_COMPLETION_ITEM, VscSymbolCompletionItemClass))

typedef struct _VscSymbolCompletionItem VscSymbolCompletionItem;
typedef struct _VscSymbolCompletionItemClass VscSymbolCompletionItemClass;

#define VSC_TYPE_SYMBOL_COMPLETION_RESULT (vsc_symbol_completion_result_get_type ())
#define VSC_SYMBOL_COMPLETION_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SYMBOL_COMPLETION_RESULT, VscSymbolCompletionResult))
#define VSC_SYMBOL_COMPLETION_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SYMBOL_COMPLETION_RESULT, VscSymbolCompletionResultClass))
#define VSC_IS_SYMBOL_COMPLETION_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SYMBOL_COMPLETION_RESULT))
#define VSC_IS_SYMBOL_COMPLETION_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SYMBOL_COMPLETION_RESULT))
#define VSC_SYMBOL_COMPLETION_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SYMBOL_COMPLETION_RESULT, VscSymbolCompletionResultClass))

typedef struct _VscSymbolCompletionResult VscSymbolCompletionResult;
typedef struct _VscSymbolCompletionResultClass VscSymbolCompletionResultClass;

#define VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS (vsc_symbol_completion_filter_options_get_type ())
#define VSC_SYMBOL_COMPLETION_FILTER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS, VscSymbolCompletionFilterOptions))
#define VSC_SYMBOL_COMPLETION_FILTER_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS, VscSymbolCompletionFilterOptionsClass))
#define VSC_IS_SYMBOL_COMPLETION_FILTER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS))
#define VSC_IS_SYMBOL_COMPLETION_FILTER_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS))
#define VSC_SYMBOL_COMPLETION_FILTER_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SYMBOL_COMPLETION_FILTER_OPTIONS, VscSymbolCompletionFilterOptionsClass))

typedef struct _VscSymbolCompletionFilterOptions VscSymbolCompletionFilterOptions;
typedef struct _VscSymbolCompletionFilterOptionsClass VscSymbolCompletionFilterOptionsClass;

#define VSC_TYPE_PARSER_MANAGER (vsc_parser_manager_get_type ())
#define VSC_PARSER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_PARSER_MANAGER, VscParserManager))
#define VSC_PARSER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_PARSER_MANAGER, VscParserManagerClass))
#define VSC_IS_PARSER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_PARSER_MANAGER))
#define VSC_IS_PARSER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_PARSER_MANAGER))
#define VSC_PARSER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_PARSER_MANAGER, VscParserManagerClass))

typedef struct _VscParserManager VscParserManager;
typedef struct _VscParserManagerClass VscParserManagerClass;
typedef struct _VscSymbolCompletionFilterOptionsPrivate VscSymbolCompletionFilterOptionsPrivate;
typedef struct _VscSymbolCompletionItemPrivate VscSymbolCompletionItemPrivate;
typedef struct _VscSymbolCompletionResultPrivate VscSymbolCompletionResultPrivate;

#define VSC_TYPE_SOURCE_BUFFER (vsc_source_buffer_get_type ())
#define VSC_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_SOURCE_BUFFER, VscSourceBuffer))
#define VSC_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_SOURCE_BUFFER, VscSourceBufferClass))
#define VSC_IS_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_SOURCE_BUFFER))
#define VSC_IS_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_SOURCE_BUFFER))
#define VSC_SOURCE_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_SOURCE_BUFFER, VscSourceBufferClass))

typedef struct _VscSourceBuffer VscSourceBuffer;
typedef struct _VscSourceBufferClass VscSourceBufferClass;
typedef struct _VscSourceBufferPrivate VscSourceBufferPrivate;

#define VSC_TYPE_METHOD_LIST (vsc_method_list_get_type ())
#define VSC_METHOD_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_METHOD_LIST, VscMethodList))
#define VSC_METHOD_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_METHOD_LIST, VscMethodListClass))
#define VSC_IS_METHOD_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_METHOD_LIST))
#define VSC_IS_METHOD_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_METHOD_LIST))
#define VSC_METHOD_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_METHOD_LIST, VscMethodListClass))

typedef struct _VscMethodList VscMethodList;
typedef struct _VscMethodListClass VscMethodListClass;
typedef struct _VscMethodListPrivate VscMethodListPrivate;

#define VSC_TYPE_CLASS_LIST (vsc_class_list_get_type ())
#define VSC_CLASS_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_CLASS_LIST, VscClassList))
#define VSC_CLASS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_CLASS_LIST, VscClassListClass))
#define VSC_IS_CLASS_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_CLASS_LIST))
#define VSC_IS_CLASS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_CLASS_LIST))
#define VSC_CLASS_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_CLASS_LIST, VscClassListClass))

typedef struct _VscClassList VscClassList;
typedef struct _VscClassListClass VscClassListClass;
typedef struct _VscClassListPrivate VscClassListPrivate;

#define VSC_TYPE_COMPLETION_VISITOR (vsc_completion_visitor_get_type ())
#define VSC_COMPLETION_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_COMPLETION_VISITOR, VscCompletionVisitor))
#define VSC_COMPLETION_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_COMPLETION_VISITOR, VscCompletionVisitorClass))
#define VSC_IS_COMPLETION_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_COMPLETION_VISITOR))
#define VSC_IS_COMPLETION_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_COMPLETION_VISITOR))
#define VSC_COMPLETION_VISITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_COMPLETION_VISITOR, VscCompletionVisitorClass))

typedef struct _VscCompletionVisitor VscCompletionVisitor;
typedef struct _VscCompletionVisitorClass VscCompletionVisitorClass;
typedef struct _VscCompletionVisitorPrivate VscCompletionVisitorPrivate;

#define VSC_TYPE_TYPEFINDER_VISITOR (vsc_typefinder_visitor_get_type ())
#define VSC_TYPEFINDER_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VSC_TYPE_TYPEFINDER_VISITOR, VscTypeFinderVisitor))
#define VSC_TYPEFINDER_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VSC_TYPE_TYPEFINDER_VISITOR, VscTypeFinderVisitorClass))
#define VSC_IS_TYPEFINDER_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VSC_TYPE_TYPEFINDER_VISITOR))
#define VSC_IS_TYPEFINDER_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VSC_TYPE_TYPEFINDER_VISITOR))
#define VSC_TYPEFINDER_VISITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VSC_TYPE_TYPEFINDER_VISITOR, VscTypeFinderVisitorClass))

typedef struct _VscTypeFinderVisitor VscTypeFinderVisitor;
typedef struct _VscTypeFinderVisitorClass VscTypeFinderVisitorClass;
typedef struct _VscTypeFinderVisitorPrivate VscTypeFinderVisitorPrivate;
typedef struct _VscParserManagerPrivate VscParserManagerPrivate;

typedef enum  {
	VSC_SYMBOL_COMPLETION_ERROR_PACKAGE_FILE_NOT_FOUND,
	VSC_SYMBOL_COMPLETION_ERROR_PACKAGE_ALREADY_ADDED,
	VSC_SYMBOL_COMPLETION_ERROR_UNSUPPORTED_SYMBOL_TYPE,
	VSC_SYMBOL_COMPLETION_ERROR_UNSUPPORTED_TYPE,
	VSC_SYMBOL_COMPLETION_ERROR_SOURCE_BUFFER
} VscSymbolCompletionError;
#define VSC_SYMBOL_COMPLETION_ERROR vsc_symbol_completion_error_quark ()
struct _VscSymbolCompletion {
	GObject parent_instance;
	VscSymbolCompletionPrivate * priv;
};

struct _VscSymbolCompletionClass {
	GObjectClass parent_class;
};

struct _VscSymbolCompletionFilterOptions {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VscSymbolCompletionFilterOptionsPrivate * priv;
	gboolean static_symbols;
	gboolean interface_symbols;
	gboolean constructors;
	gboolean instance_symbols;
	gboolean imported_namespaces;
	gboolean local_variables;
	gboolean error_domains;
	gboolean error_base;
	gboolean private_symbols;
	gboolean public_symbols;
	gboolean protected_symbols;
	gboolean internal_symbols;
	char* exclude_type;
};

struct _VscSymbolCompletionFilterOptionsClass {
	GTypeClass parent_class;
	void (*finalize) (VscSymbolCompletionFilterOptions *self);
};

struct _VscSymbolCompletionItem {
	GObject parent_instance;
	VscSymbolCompletionItemPrivate * priv;
	char* name;
	char* type_name;
	char* info;
	char* file;
	gint first_line;
	gint last_line;
	ValaSymbol* symbol;
};

struct _VscSymbolCompletionItemClass {
	GObjectClass parent_class;
};

struct _VscSymbolCompletionResult {
	GObject parent_instance;
	VscSymbolCompletionResultPrivate * priv;
	GeeList* properties;
	GeeList* classes;
	GeeList* interfaces;
	GeeList* structs;
	GeeList* methods;
	GeeList* fields;
	GeeList* signals;
	GeeList* others;
	GeeList* namespaces;
	GeeList* enums;
	GeeList* constants;
	GeeList* error_domains;
};

struct _VscSymbolCompletionResultClass {
	GObjectClass parent_class;
};

struct _VscSourceBuffer {
	GObject parent_instance;
	VscSourceBufferPrivate * priv;
};

struct _VscSourceBufferClass {
	GObjectClass parent_class;
};

struct _VscMethodList {
	ValaCodeVisitor parent_instance;
	VscMethodListPrivate * priv;
};

struct _VscMethodListClass {
	ValaCodeVisitorClass parent_class;
};

struct _VscClassList {
	ValaCodeVisitor parent_instance;
	VscClassListPrivate * priv;
};

struct _VscClassListClass {
	ValaCodeVisitorClass parent_class;
};

struct _VscCompletionVisitor {
	ValaCodeVisitor parent_instance;
	VscCompletionVisitorPrivate * priv;
};

struct _VscCompletionVisitorClass {
	ValaCodeVisitorClass parent_class;
};

struct _VscTypeFinderVisitor {
	ValaCodeVisitor parent_instance;
	VscTypeFinderVisitorPrivate * priv;
	char* qualified_typename;
};

struct _VscTypeFinderVisitorClass {
	ValaCodeVisitorClass parent_class;
};

struct _VscParserManager {
	GObject parent_instance;
	VscParserManagerPrivate * priv;
};

struct _VscParserManagerClass {
	GObjectClass parent_class;
};


GQuark vsc_symbol_completion_error_quark (void);
GType vsc_symbol_completion_get_type (void);
void vsc_symbol_completion_cleanup (VscSymbolCompletion* self);
char* vsc_symbol_completion_get_name_for_datatype (VscSymbolCompletion* self, ValaDataType* dt);
char* vsc_symbol_completion_get_qualified_name_for_datatype (VscSymbolCompletion* self, ValaDataType* dt);
GType vsc_symbol_completion_item_get_type (void);
GeeList* vsc_symbol_completion_get_methods_for_source (VscSymbolCompletion* self, const char* sourcefile);
GType vsc_symbol_completion_result_get_type (void);
VscSymbolCompletionResult* vsc_symbol_completion_get_classes_for_source (VscSymbolCompletion* self, const char* sourcefile);
VscSymbolCompletionResult* vsc_symbol_completion_get_namespaces (VscSymbolCompletion* self);
gpointer vsc_symbol_completion_filter_options_ref (gpointer instance);
void vsc_symbol_completion_filter_options_unref (gpointer instance);
GParamSpec* vsc_param_spec_symbol_completion_filter_options (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void vsc_value_set_symbol_completion_filter_options (GValue* value, gpointer v_object);
gpointer vsc_value_get_symbol_completion_filter_options (const GValue* value);
GType vsc_symbol_completion_filter_options_get_type (void);
VscSymbolCompletionResult* vsc_symbol_completion_get_visible_symbols (VscSymbolCompletion* self, VscSymbolCompletionFilterOptions* options, const char* sourcefile, gint line, gint column, gboolean types_only);
char* vsc_symbol_completion_get_datatype_name_for_name (VscSymbolCompletion* self, const char* symbolname, const char* sourcefile, gint line, gint column, GError** error);
VscSymbolCompletionResult* vsc_symbol_completion_get_completions_for_name (VscSymbolCompletion* self, VscSymbolCompletionFilterOptions* options, const char* symbolname, const char* sourcefile, gint line, gint column, GError** error);
VscSymbolCompletion* vsc_symbol_completion_new (void);
VscSymbolCompletion* vsc_symbol_completion_construct (GType object_type);
GType vsc_parser_manager_get_type (void);
VscParserManager* vsc_symbol_completion_get_parser (VscSymbolCompletion* self);
VscSymbolCompletionFilterOptions* vsc_symbol_completion_filter_options_new (void);
VscSymbolCompletionFilterOptions* vsc_symbol_completion_filter_options_construct (GType object_type);
void vsc_symbol_completion_filter_options_defaults (VscSymbolCompletionFilterOptions* self);
void vsc_symbol_completion_filter_options_public_only (VscSymbolCompletionFilterOptions* self);
VscSymbolCompletionItem* vsc_symbol_completion_item_new (const char* name);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct (GType object_type, const char* name);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_method (ValaMethod* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_method (GType object_type, ValaMethod* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_creation_method (ValaCreationMethod* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_creation_method (GType object_type, ValaCreationMethod* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_field (ValaField* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_field (GType object_type, ValaField* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_property (ValaProperty* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_property (GType object_type, ValaProperty* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_struct (ValaStruct* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_struct (GType object_type, ValaStruct* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_class (ValaClass* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_class (GType object_type, ValaClass* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_interface (ValaInterface* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_interface (GType object_type, ValaInterface* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_signal (ValaSignal* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_signal (GType object_type, ValaSignal* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_new_with_namespace (ValaNamespace* item);
VscSymbolCompletionItem* vsc_symbol_completion_item_construct_with_namespace (GType object_type, ValaNamespace* item);
gboolean vsc_symbol_completion_result_namespaces_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_classes_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_interfaces_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_structs_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_constants_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_enums_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_methods_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_delegates_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_signals_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_fields_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_properties_contain (VscSymbolCompletionResult* self, const char* name);
gboolean vsc_symbol_completion_result_error_domains_contain (VscSymbolCompletionResult* self, const char* name);
VscSymbolCompletionResult* vsc_symbol_completion_result_new (void);
VscSymbolCompletionResult* vsc_symbol_completion_result_construct (GType object_type);
gboolean vsc_symbol_completion_result_get_is_empty (VscSymbolCompletionResult* self);
gint vsc_symbol_completion_result_get_count (VscSymbolCompletionResult* self);
GType vsc_source_buffer_get_type (void);
VscSourceBuffer* vsc_source_buffer_new (const char* name, const char* source);
VscSourceBuffer* vsc_source_buffer_construct (GType object_type, const char* name, const char* source);
const char* vsc_source_buffer_get_name (VscSourceBuffer* self);
void vsc_source_buffer_set_name (VscSourceBuffer* self, const char* value);
const char* vsc_source_buffer_get_source (VscSourceBuffer* self);
void vsc_source_buffer_set_source (VscSourceBuffer* self, const char* value);
GType vsc_method_list_get_type (void);
VscMethodList* vsc_method_list_new (GeeList* methods);
VscMethodList* vsc_method_list_construct (GType object_type, GeeList* methods);
GType vsc_class_list_get_type (void);
VscClassList* vsc_class_list_new (GeeList* classes);
VscClassList* vsc_class_list_construct (GType object_type, GeeList* classes);
GType vsc_completion_visitor_get_type (void);
VscCompletionVisitor* vsc_completion_visitor_new (VscSymbolCompletionFilterOptions* options, VscSymbolCompletionResult* results, ValaSourceFile* source, ValaCodeContext* context);
VscCompletionVisitor* vsc_completion_visitor_construct (GType object_type, VscSymbolCompletionFilterOptions* options, VscSymbolCompletionResult* results, ValaSourceFile* source, ValaCodeContext* context);
void vsc_completion_visitor_integrate_completion (VscCompletionVisitor* self, ValaSymbol* symbol);
const char* vsc_completion_visitor_get_searched_typename (VscCompletionVisitor* self);
void vsc_completion_visitor_set_searched_typename (VscCompletionVisitor* self, const char* value);
GType vsc_typefinder_visitor_get_type (void);
VscTypeFinderVisitor* vsc_typefinder_visitor_new (ValaSourceFile* source, ValaCodeContext* context);
VscTypeFinderVisitor* vsc_typefinder_visitor_construct (GType object_type, ValaSourceFile* source, ValaCodeContext* context);
ValaSymbol* vsc_typefinder_visitor_get_result (VscTypeFinderVisitor* self);
const char* vsc_typefinder_visitor_get_searched_typename (VscTypeFinderVisitor* self);
void vsc_typefinder_visitor_set_searched_typename (VscTypeFinderVisitor* self, const char* value);
void vsc_parser_manager_suspend_parsing (VscParserManager* self);
void vsc_parser_manager_resume_parsing (VscParserManager* self);
gboolean vsc_parser_manager_add_path_to_vapi_search_dir (VscParserManager* self, const char* path);
gboolean vsc_parser_manager_add_built_package (VscParserManager* self, const char* vapi_file);
gboolean vsc_parser_manager_remove_build_package (VscParserManager* self, const char* vapi_file);
gboolean vsc_parser_manager_add_package_from_namespace (VscParserManager* self, const char* namespace, gboolean auto_schedule_parse, GError** error);
void vsc_parser_manager_remove_package_from_namespace (VscParserManager* self, const char* namespace, GError** error);
void vsc_parser_manager_remove_package (VscParserManager* self, const char* package_name, GError** error);
gboolean vsc_parser_manager_try_add_package (VscParserManager* self, const char* package_name, gboolean auto_schedule_parse);
gboolean vsc_parser_manager_add_package (VscParserManager* self, const char* package_name, gboolean auto_schedule_parse, GError** error);
void vsc_parser_manager_add_source (VscParserManager* self, const char* filename, GError** error);
void vsc_parser_manager_remove_source (VscParserManager* self, const char* filename, GError** error);
gboolean vsc_parser_manager_contains_source (VscParserManager* self, const char* filename);
void vsc_parser_manager_add_source_buffer (VscParserManager* self, VscSourceBuffer* source, GError** error);
void vsc_parser_manager_remove_source_buffer_by_name (VscParserManager* self, const char* name, GError** error);
gboolean vsc_parser_manager_contains_source_buffer (VscParserManager* self, VscSourceBuffer* source);
gboolean vsc_parser_manager_contains_source_buffer_by_name (VscParserManager* self, const char* name);
void vsc_parser_manager_remove_source_buffer (VscParserManager* self, VscSourceBuffer* source);
void vsc_parser_manager_reparse_source_buffers (VscParserManager* self);
gboolean vsc_parser_manager_is_cache_building (VscParserManager* self);
void vsc_parser_manager_reparse (VscParserManager* self, gboolean all_context);
void vsc_parser_manager_parse_context (VscParserManager* self, ValaCodeContext* context);
VscParserManager* vsc_parser_manager_new (void);
VscParserManager* vsc_parser_manager_construct (GType object_type);


G_END_DECLS

#endif
